# arquivo jpeg.m

#####################################################
### JPEG aplicada a uma imagem usando GNU Octave  ###
#####################################################

# lendo o pacote que implementa a funcao dct2 (2 de 2D)
pkg load signal

# lendo a imagem ponte.pgm numa matriz
A = imread('ponte.pgm');

# inicializando as matrizes
B = zeros(512,512);  C = B;

# matrizes de quantizacao
Q = [ 16, 11, 10, 16, 24, 40, 51, 61 ;
      12, 12, 14, 19, 26, 58, 60, 55 ;
      14, 13, 16, 24, 40, 57, 69, 56 ;
      14, 17, 22, 29, 51, 87, 80, 62 ;
      18, 22, 37, 56, 68, 109, 103, 77 ;
      24, 35, 55, 64, 81, 104, 113, 92 ;
      49, 64, 78, 87, 103, 121, 120, 101 ;
      72, 92, 95, 98, 112, 100, 103, 99];

hQ = .5*Q;

# ha 64x64 blocos 8x8 na imagem original
for i = 1:64
  for j = 1:64
    # separando a matriz A em blocos de 8x8
    M = A(8*i-7:8*i,8*j-7:8*j);
    # aplicando a DCT com matrizes de quantizacao .5Q e Q
    N = round( idct2( round( dct2(M) ./ hQ ) .* hQ ) );
    K = round( idct2( round( dct2(M) ./ Q ) .* Q ) );
    # salvando os blocos nas matrizes B e C
    B(8*i-7:8*i,8*j-7:8*j) = N;
    C(8*i-7:8*i,8*j-7:8*j) = K;
  end
end

# cortando valores entre 0 e 255
B = max( min( B, 255 ), 0 );
C = max( min( C, 255 ), 0 );

# o formato pgm eh um formato de imagens de facil programacao
# inicia com P2 (indica escala de cinza com valores em texto)
# seguida das dimensoes da imagem e do valor maximo que
# corresponderah ao branco, seguido de uma sequencias de
# inteiros entre 0 e o maximo informado

# escrevendo os arquivos
# note que as matrizes sao escritas transpostas 
fB = fopen('ponte-hQ.pgm','w');
fprintf(fB,"P2\n512 512\n255\n");
fprintf(fB,"%i\n",B');
fclose(fB);

fC = fopen('ponte-Q.pgm','w');
fprintf(fC,"P2\n512 512\n255\n");
fprintf(fC,"%i\n",C');
fclose(fC);

# agora trabalhando na selecao 8x8
R = A(158:165,297:304)

# aplicando a compressao JPEG na regiao
S = round( idct2( round( dct2(R) ./ Q ) .* Q ) );
# cortando valores entre 0 e 255
S = max( min( S, 255 ), 0 );

# escrevendo as duas imagens
fR = fopen('regiao.pgm','w');
fprintf(fR,"P2\n8 8\n255\n");
fprintf(fR,"%i\n",R');
fclose(fR);

fR = fopen('regiao-Q.pgm','w');
fprintf(fR,"P2\n8 8\n255\n");
fprintf(fR,"%i\n",S');
fclose(fR);

# fim do jpeg.m
